package com.hzs.common.core.enums.retail;

import com.hzs.common.core.enums.EGrade;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.math.BigDecimal;

/**
 * 新零售商品等级价格枚举
 */
@AllArgsConstructor
@Getter
public enum ERetailWaresPrice {

    /**
     * V0（20）
     */
    V0(EGrade.START_UP.getValue(), new BigDecimal("399")),
    /**
     * V1（30）
     */
    V1(EGrade.HAI_FAN.getValue(), new BigDecimal("399")),
    /**
     * V2（40）
     */
    V2(EGrade.YOU_KE.getValue(), new BigDecimal("399")),
    /**
     * V3（50）
     */
    V3(EGrade.MAKER.getValue(), new BigDecimal("399")),
    /**
     * V4（60）
     */
    V4(EGrade.VIP.getValue(), new BigDecimal("399")),
    /**
     * V5（70）
     */
    V5(EGrade.S_VIP.getValue(), new BigDecimal("399")),

    ;

    /**
     * 等级值（EGrade中的value)
     */
    private final int value;

    /**
     * 价格
     */
    private final BigDecimal price;

    /**
     * 根据枚举值获取枚举
     *
     * @param value 枚举值
     * @return
     */
    public static ERetailWaresPrice getEnumByValue(int value) {
        for (ERetailWaresPrice eRetailWaresPrice : ERetailWaresPrice.values()) {
            if (eRetailWaresPrice.value == value) {
                return eRetailWaresPrice;
            }
        }
        return V0;
    }

}
